﻿using UnityEngine;
using System.Collections;

public class BulletController : MonoBehaviour {

	private int _worldNumber;
	public int WorldNumber
	{
		get
		{
			return _worldNumber;
		}
		set
		{
			switch (value)
			{
			case -1:
				gameObject.layer = 9;
				break;
			case 0:
				gameObject.layer = 10;
				break;
			case 1:
				gameObject.layer = 11;
				break;
			}
			_worldNumber = value;
		}
	}
	public bool enemyBullet = false;
	private int dmg;
	public float speed;
	public float lifeTime;

	private Vector3 moveVector = Vector3.zero;

	// Use this for initialization
	void Start () {
	
	}

	void Update()
	{
		if (lifeTime >= 0)
		{
			lifeTime -= Time.deltaTime;
		}
		else
		{
			Destroy(gameObject);
		}
	}

	void FixedUpdate () {
		transform.position += moveVector;
	}

	public void SetDirectionAndFire(Vector3 direction, int dmg)
	{
		moveVector = direction * speed;
		this.dmg = dmg;
	}

	void OnTriggerEnter2D(Collider2D collider) {
		if (!enemyBullet && collider.transform.tag == "Machar") return;
		if (enemyBullet && collider.transform.tag == "Enemy") return;
		if (collider.transform.tag == "BulletPassable") return;
		collider.gameObject.SendMessage("GotHit",new HitB(dmg,moveVector),SendMessageOptions.DontRequireReceiver);
		Destroy(gameObject);
	}
}
