﻿using UnityEngine;
using System.Collections;

public class EnemyController : MonoBehaviour {

	private int _worldNumber;
	public int WorldNumber
	{
		get
		{
			return _worldNumber;
		}
		set
		{
			switch (value)
			{
			case -1:
				gameObject.layer = 9;
				target = GameObject.Find("Machar0");
				break;
			case 0:
				gameObject.layer = 10;
				target = GameObject.Find("Machar0");
				break;
			case 1:
				gameObject.layer = 11;
				target = GameObject.Find("Machar1");
				break;
			}
			_worldNumber = value;
		}
	}
	public GameObject bullet;
	public GameObject bulletsFolder;
	private GameObject target;
	Animator anim;
	private float currentCooldown = 0;

	public float hp;
	public float moveSpeed;
	public float attackCooldown;
	public int dmgMelee;
	public int dmgRifle;
	public int difficultyLevel;
	private Vector3 moveVector;

	// Use this for initialization
	void Start () {
		anim = transform.GetComponent<Animator>();
		bulletsFolder = GameObject.Find("Bullets").gameObject;
	}
	
	// Update is called once per frame
	void Update () {
		if (hp <= 0)
		{
			Director.Instance.GetComponent<Director>().AddKill(1);
			Destroy(gameObject);
		}
	}

	void FixedUpdate ()
	{
		Vector3 newPosition = Vector3.MoveTowards(transform.position,target.transform.position,moveSpeed);
		moveVector = newPosition-transform.position;
		currentCooldown -= Time.deltaTime;
		if (currentCooldown <= 0)
		{
			currentCooldown = 0;
		}
		if (dmgMelee > 0 && currentCooldown == 0 && Vector3.Distance(transform.position, target.transform.position) < 1.5f)
		{
			StartCoroutine("AttackMelee");
		}
		if (dmgRifle > 0 && currentCooldown == 0 && Vector3.Distance(transform.position, target.transform.position) < 10f && moveVector != Vector3.zero)
		{
			StartCoroutine("AttackRifle");
		}
		else
		{

			if (moveVector.magnitude > 0.01)
			{
				anim.SetFloat("movSpeed", moveSpeed);
			}
			if (moveVector.y > 0)
			{
				anim.SetBool("isUp", true);

				if (moveVector.x > 0 )
				{
					transform.localScale = new Vector3(1,1,1);
				}
				else
				{
					transform.localScale = new Vector3(-1,1,1);
				}
			}
			else
			{
				anim.SetBool("isUp", false);
				
				if (moveVector.x > 0 )
				{
					transform.localScale = new Vector3(-1,1,1);
				}
				else
				{
					transform.localScale = new Vector3(1,1,1);
				}
			}
			transform.position = newPosition;
		}
	}

	IEnumerator AttackMelee() {
		anim.SetTrigger("Attack");
		currentCooldown += attackCooldown;
		yield return new WaitForSeconds(0.3f);
		target.SendMessage("GotHit",new HitB(dmgMelee,moveVector),SendMessageOptions.DontRequireReceiver);
	}

	IEnumerator AttackRifle() {
		anim.SetTrigger("Attack");
		currentCooldown += attackCooldown;
		yield return new WaitForSeconds(0.5f);
		FireBullet(bullet, (transform.position-target.transform.position).normalized*-1);
	}

	//skopiowane zamiast dziedziczone - jak cała masa innych rzeczy :P
	void FireBullet(GameObject bullet, Vector3 direction)
	{
		Vector3 bulletPosition = transform.position + 0.5f * direction;
		GameObject createdBullet = GameObject.Instantiate (bullet, bulletPosition, new Quaternion ()) as GameObject;
		createdBullet.transform.parent = bulletsFolder.transform;
		createdBullet.GetComponent<BulletController>().WorldNumber = WorldNumber;
		createdBullet.GetComponent<BulletController>().enemyBullet = true;
		createdBullet.GetComponent<BulletController>().SetDirectionAndFire(direction, dmgRifle);
		AudioManager.Instance.PlaySound(AudioManager.Sound.PewPew);
	}

	public void GotHit(HitB hitInfo)
	{
		anim.SetTrigger("GotHit");
		Vector3 newPosition = transform.position + hitInfo.MoveVector.normalized * 0.25f;
		transform.position = newPosition;

		hp -= hitInfo.Dmg;
		AudioManager.Instance.PlaySound(AudioManager.Sound.Hit);
	}
}
