﻿using UnityEngine;
using System.Collections;

public class MacharController : MonoBehaviour {

	public int worldNumber;

	public GameObject bullet;
	
	private GameObject bulletsFolder;
	
	//private int activeWeapon = 1;
	private float currentCooldown = 0;
	Animator anim;
	public float moveSpeed = 0.1f;
	public int dmg;

	// Use this for initialization
	void Start () {
		anim = transform.GetComponent<Animator>();
		bulletsFolder = GameObject.Find("Bullets").gameObject;
	}

	void Update()
	{

		/*if (Input.GetKeyDown(KeyCode.Alpha1))
		{
			activeWeapon = 1;
		}
		if (Input.GetKeyDown(KeyCode.Alpha2))
		{
			activeWeapon = 2;
		}*/

		currentCooldown -= Time.deltaTime;
		if (currentCooldown <= 0)
		{
			currentCooldown = 0;
			{
				if (Input.GetKey(KeyCode.LeftArrow))
				{
					UseAttack(Vector3.left);
				}
				else if (Input.GetKey(KeyCode.RightArrow))
				{
					UseAttack(Vector3.right);
				}
				else if (Input.GetKey(KeyCode.UpArrow))
				{
					UseAttack(Vector3.up);
				}
				else if (Input.GetKey(KeyCode.DownArrow))
				{
					UseAttack(Vector3.down);
				}
			}
		}
	}

	void FixedUpdate ()
	{
		Vector3 moveVector = Vector3.zero;
		moveVector += Input.GetAxis("Horizontal") * moveSpeed * Vector3.right;
		moveVector += Input.GetAxis("Vertical") * moveSpeed * Vector3.up;
		if (moveVector.magnitude > 0)
		{
			anim.SetFloat("movSpeed", moveVector.magnitude);
		}
		if (moveVector.x > 0)
		{
			transform.localScale = new Vector3(-1,1,1);
		}
		else
		{
			transform.localScale = new Vector3(1,1,1);
		}
		if (moveVector.y > 0)
		{
			anim.SetBool("isUp", true);
		}
		else
		{
			anim.SetBool("isUp", false);
		}
		transform.position += moveVector;
	}

	void UseAttack(Vector3 direction)
	{
		switch (worldNumber)
		{
		case 0:
			FireBullet(bullet, direction);
			currentCooldown += 0.3f;
			/*switch (activeWeapon)
			{
			case 1:
				FireBullet(bullets[0], direction);
				currentCooldown += 0.3f;
				break;
			case 2:
				FireBullet(bullets[1], direction);
				currentCooldown += 1f;
				break;
			}*/
			break;
		case 1:
			FireBullet(bullet, direction);
			currentCooldown += 0.3f;
			/*switch (activeWeapon)
			{
			case 1:
				FireBullet(bullets[0], direction);
				currentCooldown += 0.3f;
				break;
			case 2:
				FireBullet(bullets[1], direction);
				currentCooldown += 1f;
				break;
			}*/
			break;
		}
	}

	void FireBullet(GameObject bullet, Vector3 direction)
	{
		Vector3 bulletPosition = transform.position + 0.5f * direction;
		GameObject createdBullet = GameObject.Instantiate (bullet, bulletPosition, new Quaternion ()) as GameObject;
		createdBullet.transform.parent = bulletsFolder.transform;
		createdBullet.GetComponent<BulletController>().WorldNumber = worldNumber;
		createdBullet.GetComponent<BulletController>().SetDirectionAndFire(direction, dmg);
		AudioManager.Instance.PlaySound(AudioManager.Sound.PewPew);
	}

	public void GotHit(HitB hitInfo)
	{
		anim.SetTrigger("GotHit");
		Vector3 newPosition = transform.position + hitInfo.MoveVector.normalized * 0.25f;
		transform.position = newPosition;
		Director.Instance.GetComponent<Director>().LowerHp(hitInfo.Dmg);
		AudioManager.Instance.PlaySound(AudioManager.Sound.Hurt);
	}

}
