﻿using UnityEngine;
using System.Collections;

public class Portal : MonoBehaviour {

	public int worldNumber;
	public GameObject[] enemies;
	Animator anim;

	public float nextSpawnTimer = 1f;
	public float spawnCooldown = 2f;
	private int toSpawn = 0;

	// Use this for initialization
	void Start () {
		anim = transform.GetComponent<Animator>();
	}
	
	// Update is called once per frame
	void Update () {
		nextSpawnTimer -= Time.deltaTime;
		if (nextSpawnTimer < 0)
		{
			if (toSpawn <= 0)
			{
				anim.SetTrigger("Close");
			}
			else
			{
				int enemyType = Random.Range(0,6);
				if (toSpawn < 5)
				{
					enemyType = 0;
				}
				SpawnEnemy(enemyType);
				nextSpawnTimer += spawnCooldown;
				toSpawn -= enemies[enemyType].GetComponent<EnemyController>().difficultyLevel;
			}
		}
		if (anim.GetCurrentAnimatorStateInfo(0).IsName("Closed"))
		{
			Destroy(gameObject);
		}
	}

	void SpawnEnemy(int enemyType)
	{
		//Vector3 spawnPosition = transform.position +  Quaternion.Euler(0, 90, 0) * new Vector3(2f, 0, 0);
		Vector3 spawnPosition = transform.position;
		GameObject createdEnemy = GameObject.Instantiate (enemies[enemyType], spawnPosition, new Quaternion ()) as GameObject;
		createdEnemy.GetComponent<EnemyController>().WorldNumber = worldNumber;
	}

	public void SetDifficulty(int difficulty)
	{
		if (difficulty < 12)
		{
			nextSpawnTimer = 2f;
			spawnCooldown = 3f;
		}
		if (difficulty > 29)
		{
			nextSpawnTimer = 2f;
			spawnCooldown = 6f;
		}
		toSpawn = difficulty;
	}
}
